# Arrays are better suited than lists to handle elements all of the
# same type.
import array

# Let's see how long it takes to parse all the data.
import time
start_time = time.time()

# Read in the entire data file as a single string.
f = file('plug-halloween.dat', 'r')

# Create an array for each of the sensors and the time in seconds at
# which the sensors were read.
seconds = array.array('d')
light = array.array('B')
microphone = array.array('B')
voltage = array.array('B')
expansion = array.array('B')
current4 = array.array('B')
current2 = array.array('B')
current3 = array.array('B')
current1 = array.array('B')
vibratab = array.array('B')

# Parse the data.
while True :
    buf = []
    c = f.read(1)
    if c == '' :
        break
    while c != '\n' :
        buf.append(c)
        c = f.read(1)
    seconds.append(float(''.join(buf)))
    light.append(ord(f.read(1)))
    microphone.append(ord(f.read(1)))
    voltage.append(ord(f.read(1)))
    expansion.append(ord(f.read(1)))
    current4.append(ord(f.read(1)))
    current2.append(ord(f.read(1)))
    current3.append(ord(f.read(1)))
    current1.append(ord(f.read(1)))
    vibratab.append(ord(f.read(1)))
    assert f.read(1) == '\n'

f.close()
end_time = time.time()

print "Elapsed time to parse data:", end_time-start_time
